%% 2004 data
clear all; close all;
[ndata, text, alldata] = xlsread('TIP_2004_papers.xls');
alldata2 = alldata(3:end,:);

% analyze citations using Google Scholar text file
fid = fopen('TIP_2004_citations_GS_12_02_18.txt');
text_gs = textscan(fid, '%s', 'delimiter', '\n', 'bufsize', 100000);
fclose(fid);

n = 0;
start = 1;
errors = [];
for i=1:length(text_gs{1})
    if (isempty(text_gs{1}{i}))
        tmp = regexp(text_gs{1}{i-1},'Geciteerd door [0-9]*', 'match');
        if (~isempty(tmp))
            n = n+1;
            title{n} = text_gs{1}{start};
            citations(n) = str2num(tmp{1}(16:end));
        else
            errors = [errors; i];
            errortexts{i} = text_gs{1}{start};
        end
        gs_parts(n,:) = [start i-1];
        start = i+1;
    end
end

% match citations with ref titles
fid2 = fopen('TIP_2004_GSmatchesnotfound.txt','w');
citcol = 7;
titlecol = 1;

matchnotfound = [];
citations_ref = zeros(1,size(alldata2,1));
for n=1:size(alldata2,1)
    alldata2{n,citcol} = 0;
end
for n=1:length(title)
    paper = title{n};
    notfound = 1; i = 1;
    while (notfound && i<= size(alldata2,1))
        notfound = ~strcmp(lower(paper),lower(strtrim(alldata2{i,titlecol})));
        if (notfound == 0)
            paperid(n) = i;
            alldata2{i,citcol} = alldata2{i,citcol} + citations(n);
        end
        i = i+1;
    end
    if (i>size(alldata2,1))
        % error, not found
        matchnotfound = [matchnotfound; n];
        for ind = gs_parts(n,1):gs_parts(n,2)
            fprintf(fid2, [text_gs{1}{ind} '\n']);
        end
        fprintf(fid2, '\n');
    end
end
fid2 = fclose(fid2);

% write results
alldata_out(1:2,:) = alldata(1:2,:); % add header again
alldata_out(3:size(alldata,1),:) = alldata2;
xlswrite('TIP_2004_papers.xls',alldata_out);

%% 2005 data
clear all; close all;
[ndata, text, alldata] = xlsread('TIP_2005_papers.xls');
alldata2 = alldata(3:end,:);

% analyze citations using Google Scholar text file
fid = fopen('TIP_2005_citations_GS_12_02_18.txt');
text_gs = textscan(fid, '%s', 'delimiter', '\n', 'bufsize', 100000);
fclose(fid);

n = 0;
start = 1;
errors = [];
for i=1:length(text_gs{1})
    if (isempty(text_gs{1}{i}))
        tmp = regexp(text_gs{1}{i-1},'Geciteerd door [0-9]*', 'match');
        if (~isempty(tmp))
            n = n+1;
            title{n} = text_gs{1}{start};
            citations(n) = str2num(tmp{1}(16:end));
        else
            errors = [errors; i];
            errortexts{i} = text_gs{1}{start};
        end
        gs_parts(n,:) = [start i-1];
        start = i+1;
    end
end

% match citations with ref titles
fid2 = fopen('TIP_2005_GSmatchesnotfound.txt','w');
citcol = 7;
titlecol = 1;

matchnotfound = [];
citations_ref = zeros(1,size(alldata2,1));
for n=1:size(alldata2,1)
    alldata2{n,citcol} = 0;
end
for n=1:length(title)
    paper = title{n};
    notfound = 1; i = 1;
    while (notfound && i<= size(alldata2,1))
        notfound = ~strcmp(lower(paper),lower(strtrim(alldata2{i,titlecol})));
        if (notfound == 0)
            paperid(n) = i;
            alldata2{i,citcol} = alldata2{i,citcol} + citations(n);
        end
        i = i+1;
    end
    if (i>size(alldata2,1))
        % error, not found
        matchnotfound = [matchnotfound; n];
        for ind = gs_parts(n,1):gs_parts(n,2)
            fprintf(fid2, [text_gs{1}{ind} '\n']);
        end
        fprintf(fid2, '\n');
    end
end
fid2 = fclose(fid2);

% write results
alldata_out(1:2,:) = alldata(1:2,:); % add header again
alldata_out(3:size(alldata,1),:) = alldata2;
xlswrite('TIP_2005_papers.xls',alldata_out);

%% 2006 data
clear all; close all;
[ndata, text, alldata] = xlsread('TIP_2006_papers.xls');
alldata2 = alldata(3:end,:);

% analyze citations using Google Scholar text file
fid = fopen('TIP_2006_citations_GS_12_02_18.txt');
text_gs = textscan(fid, '%s', 'delimiter', '\n', 'bufsize', 100000);
fclose(fid);

n = 0;
start = 1;
errors = [];
for i=1:length(text_gs{1})
    if (isempty(text_gs{1}{i}))
        tmp = regexp(text_gs{1}{i-1},'Geciteerd door [0-9]*', 'match');
        if (~isempty(tmp))
            n = n+1;
            title{n} = text_gs{1}{start};
            citations(n) = str2num(tmp{1}(16:end));
        else
            errors = [errors; i];
            errortexts{i} = text_gs{1}{start};
        end
        gs_parts(n,:) = [start i-1];
        start = i+1;
    end
end

% match citations with ref titles
fid2 = fopen('TIP_2006_GSmatchesnotfound.txt','w');
citcol = 7;
titlecol = 1;

matchnotfound = [];
citations_ref = zeros(1,size(alldata2,1));
for n=1:size(alldata2,1)
    alldata2{n,citcol} = 0;
end
for n=1:length(title)
    paper = title{n};
    notfound = 1; i = 1;
    while (notfound && i<= size(alldata2,1))
        notfound = ~strcmp(lower(paper),lower(strtrim(alldata2{i,titlecol})));
        if (notfound == 0)
            paperid(n) = i;
            alldata2{i,citcol} = alldata2{i,citcol} + citations(n);
        end
        i = i+1;
    end
    if (i>size(alldata2,1))
        % error, not found
        matchnotfound = [matchnotfound; n];
        for ind = gs_parts(n,1):gs_parts(n,2)
            fprintf(fid2, [text_gs{1}{ind} '\n']);
        end
        fprintf(fid2, '\n');
    end
end
fid2 = fclose(fid2);

% write results
alldata_out(1:2,:) = alldata(1:2,:); % add header again
alldata_out(3:size(alldata,1),:) = alldata2;
xlswrite('TIP_2006_papers.xls',alldata_out);